TrcPktDecodeBase< P, Pc > Class Template Reference
OpenCSD Library : Packet Decoders.

`#include <trc_pkt_decode_base.h>`

Inheritance diagram for TrcPktDecodeBase< P, Pc >:
[legend]
Collaboration diagram for TrcPktDecodeBase< P, Pc >:
[legend]

## Public Member Functions

| TrcPktDecodeBase (const char *component_name)
| TrcPktDecodeBase (const char *component_name, int instIDNum)
virtual | ~TrcPktDecodeBase ()
virtual ocsd_datapath_resp_t | PacketDataIn (const ocsd_datapath_op_t op, const ocsd_trc_index_t index_sop, const P *p_packet_in)
ocsd_err_t | setProtocolConfig (const Pc *config)
const Pc * | getProtocolConfig () const
Public Member Functions inherited from TrcPktDecodeI
| TrcPktDecodeI (const char *component_name)
| TrcPktDecodeI (const char *component_name, int instIDNum)
virtual | ~TrcPktDecodeI ()
componentAttachPt< ITrcGenElemIn > * | getTraceElemOutAttachPt ()
componentAttachPt< ITargetMemAccess > * | getMemoryAccessAttachPt ()
componentAttachPt< IInstrDecode > * | getInstrDecodeAttachPt ()
void | setUsesMemAccess (bool bUsesMemaccess)
const bool | getUsesMemAccess () const
void | setUsesIDecode (bool bUsesIDecode)
const bool | getUsesIDecode () const
Public Member Functions inherited from TraceComponent
| TraceComponent (const std::string &name)
| TraceComponent (const std::string &name, int instIDNum)
virtual | ~TraceComponent ()
const std::string & | getComponentName () const
void | setComponentName (const std::string &name)
componentAttachPt< ITraceErrorLog > * | getErrorLogAttachPt ()
ocsd_err_t | setComponentOpMode (uint32_t op_flags)
const uint32_t | getComponentOpMode () const
const uint32_t | getSupportedOpModes () const
void | setAssocComponent (TraceComponent *assocComp)
TraceComponent * | getAssocComponent ()
void | LogDefMessage (const std::string &msg)
Public Member Functions inherited from IPktDataIn< P >
| IPktDataIn ()
virtual | ~IPktDataIn ()
Public Member Functions inherited from ITrcTypedBase
| ITrcTypedBase ()
virtual | ~ITrcTypedBase ()

## Protected Member Functions

void | ClearConfigObj ()
Protected Member Functions inherited from TrcPktDecodeI
virtual ocsd_datapath_resp_t | processPacket ()=0
virtual ocsd_datapath_resp_t | onEOT ()=0
virtual ocsd_datapath_resp_t | onReset ()=0
virtual ocsd_datapath_resp_t | onFlush ()=0
virtual ocsd_err_t | onProtocolConfig ()=0
virtual const uint8_t | getCoreSightTraceID ()=0
const bool | checkInit ()
virtual void | onFirstInitOK ()
ocsd_datapath_resp_t | outputTraceElement (const OcsdTraceElement &elem)
ocsd_datapath_resp_t | outputTraceElementIdx (ocsd_trc_index_t idx, const OcsdTraceElement &elem)
ocsd_err_t | accessMemory (const ocsd_vaddr_t address, const ocsd_mem_space_acc_t mem_space, uint32_t *num_bytes, uint8_t *p_buffer)
ocsd_err_t | instrDecode (ocsd_instr_info *instr_info)
Protected Member Functions inherited from TraceComponent
void | LogError (const ocsdError &Error)
void | LogMessage (const ocsd_err_severity_t filter_level, const std::string &msg)
const ocsd_err_severity_t | getErrorLogLevel () const
const bool | isLoggingErrorLevel (const ocsd_err_severity_t level) const
void | updateErrorLogLevel ()
void | do_attach_notify (const int num_attached)
void | Init (const std::string &name)

## Protected Attributes

Pc * | m_config
const P * | m_curr_packet_in
Protected Attributes inherited from TrcPktDecodeI
componentAttachPt< ITrcGenElemIn > | m_trace_elem_out
componentAttachPt< ITargetMemAccess > | m_mem_access
componentAttachPt< IInstrDecode > | m_instr_decode
ocsd_trc_index_t | m_index_curr_pkt
bool | m_decode_init_ok
| set true if all attachments in place for decode. (remove checks in main throughput paths) More...
bool | m_config_init_ok
| set true if config set. More...
std::string | init_err_msg
| error message for init error More...
bool | m_uses_memaccess
bool | m_uses_idecode
Protected Attributes inherited from TraceComponent
uint32_t | m_op_flags
| current component operational mode flags. More...
uint32_t | m_supported_op_flags
| supported component operational mode flags - derived class to intialise. More...

## Detailed Description

### template<class P, class Pc>
class TrcPktDecodeBase< P, Pc >

Definition at line 185 of file trc_pkt_decode_base.h.

## Member Function Documentation

## getProtocolConfig()

template<class P , class Pc >

const Pc* TrcPktDecodeBase< P, Pc >::getProtocolConfig | ( |  | ) | const

inline

Definition at line 199 of file trc_pkt_decode_base.h.

## Member Data Documentation

## m_config

template<class P , class Pc >

Pc* TrcPktDecodeBase< P, Pc >::m_config

protected

Definition at line 205 of file trc_pkt_decode_base.h.

## m_curr_packet_in

template<class P , class Pc >

const P* TrcPktDecodeBase< P, Pc >::m_curr_packet_in

protected

Definition at line 207 of file trc_pkt_decode_base.h.

The documentation for this class was generated from the following file:

- /build/libopencsd-nipXOR/libopencsd-1.2.0/decoder/include/common/trc_pkt_decode_base.h